#!/bin/sh
# Common Ml Auto Service server (CMAS)
#	Copyright 1993,1994,1995,1996 (C) SAITOH-Ely-Yasuhiro.
#	All rights reserved.
#
VERSION=@VER@

#
# Set path of sendmail
#
SENDMAIL=@SENDMAIL@

#
# Set local environment.
#
DOMAIN=@DOMAIN@
ORGDOM=@DOMAIN@
DRIVER=@DRIVER@
MSPOOL=@MSPOOL@
PATH=@PATH@
AWK=@AWK@
GREP=@GREP@
export PATH
umask 022
unset LANG

# Get PID
MYPID=$$

# Get name of Mailing List.
ML=$1

# Set work file.
HEAD=/tmp/HEAD.$$
BODY=/tmp/BODY.$$
TEMP=/tmp/TEMP.$$
SEND=/tmp/SEND.$$
SYSM=/tmp/SYSM.$$
MAIL=/tmp/MAIL.$$

LKEY=$DRIVER/$ML/.LOCK
LOCK=$DRIVER/$ML/.LOCK.lock

DGSTFILE=$MSPOOL/$ML/spool/.digest

trap "rm -f $MAIL $HEAD $BODY $TEMP $SEND $SYSM $LOCK; exit 0" 0 1 2 3 15

# Save Article.
cat > $MAIL

# make lock key
if [ ! -f $LKEY ]
then
	touch $LKEY
fi

# check manual execute.
MANUALADD=
if [ $# -eq 2 ]
then
	MANUALADD="MANUAL"
fi

# Set default value.
. $DRIVER/config.default

if [ -f $DRIVER/$ML/config.$ML ]
then
	. $DRIVER/$ML/config.$ML
fi

# get error log?
if [ "$ERRORLOG" = "DO" ]
then
	LOGDIR=$DRIVER/$ML/LOGS
	if [ ! -d $LOGDIR ]
	then
		mkdir $LOGDIR
	fi
	CMASLOG=$LOGDIR/cmaslog.$$

	trap "rm -f $CMASLOG $MAIL $HEAD $BODY $TEMP $SEND $SYSM $LOCK; exit 0" 0
	trap "rm -f $MAIL $HEAD $BODY $TEMP $SEND $SYSM $LOCK; exit 0" 1 2 3 15

	cat $MAIL > $CMASLOG
fi	

# Check change domain name.
if [ "$GENERICFROM" ]
then
	DOMAIN=$GENERICFROM
fi

SPOOL=$MSPOOL/$ML/spool
LIST=$DRIVER/$ML/$ML-list
PROFILE=$MSPOOL/$ML/profile
GCOSFILE=$MSPOOL/$ML/profile/.gcos

if [ ! "$MESSAGES" ]
then
	MESSAGES=messages
fi

# Make unix-from address.
UnixFrom=$ML-request@$DOMAIN
MYADDRESS=$ML-control@$DOMAIN

# Change member list.
egrep "^[0-9][0-9][0-9] " $LIST 2>&1 > /dev/null
if [ $? -eq 0 ]
then
	# Get Lock.
	DELAY=`expr $MYPID % 6`

	# Get delay time.
	case "$DELAY" in
	0)	set 1 2 3 3 2 1 ;;
	1)	set 1 3 2 1 2 3 ;;
	2)	set 2 1 3 1 3 2 ;;
	3)	set 2 3 1 2 1 3 ;;
	4)	set 3 1 2 2 3 1 ;;
	*)	set 3 2 1 3 1 2 ;;
	esac

	umask 077
	until ln $LKEY $LOCK >/dev/null 2>&1
	do
		DELAY=$1
		shift
		set $@ $DELAY
		sleep $DELAY
	done
	# Lock comprele.
	umask 022

	# Update member list.
	if [ -f $LIST ]
	then
		sed -e '/^[0-9][0-9][0-9] /s/^/0/' $LIST >$TEMP
		cp $TEMP $LIST
	fi

	# Update GCOS file.
	if [ -f $GCOSFILE ]
	then
		sed -e '/^[0-9][0-9][0-9] /s/^/0/' $GCOSFILE >$TEMP
		cp $TEMP $GCOSFILE
	fi

	# Rename user profiles.
	if cd $PROFILE
	then
		for f in [0-9][0-9][0-9]
		do
			mv $f 0$f
		done
	fi

	rm -rf $LOCK
fi

# Get header
sed -n -e '1,/^$/p' < $MAIL > $HEAD

# Get body.
sed -e '1,/^$/d' < $MAIL > $BODY

# Check header.
FROM=`$AWK '
	BEGIN {rcv = 0;}
	/^$/, NR == 0 { next;}
	/^From / {next;}
	/^[Ff][Rr][Oo][Mm]:/ {rcv = 1; print; next;}
	/^[ 	]/ && rcv == 1 {print; next;}
	{rcv = 0};' < $HEAD | sed 's/[Ff][Rr][Oo][Mm]: //'`

echo $FROM | $GREP "@" >/dev/null 2>&1
if [ $? -ne 0 ]
then
	GCOS="`echo $FROM | \
	sed  -e 's/<.*>//' -e 's/.*(//' -e 's/).*//' -e 's/[ 	]*$//'`"
	set `echo $FROM | sed -e "s/(.*)//" -e "s/.*<//" -e "s/>.*//"` 
	AD=$1
        FROM="$AD@$ORGDOM ($GCOS)"
fi

REPLYTO=`$AWK '
	BEGIN {rcv = 0;}
	/^$/, NR == 0 { next;}
	/^From / {next;}
	/^[Rr][Ee][Pp][Ll][Yy]-[Tt][Oo]:/ {rcv = 1; print; next;}
	/^[ 	]/ && rcv == 1 {print; next;}
	{rcv = 0};' < $HEAD | sed 's/[Rr][Ee][Pp][Ll][Yy]-[Tt][Oo]: //'`

if [ "$REPLYTO" ]
then
	echo $REPLYTO | $GREP "@" >/dev/null 2>&1
	if [ $? -ne 0 ]
	then
		GCOS="`echo $REPLYTO | \
		sed  -e 's/<.*>//' -e 's/.*(//' -e 's/).*//' -e 's/[ 	]*$//'`"
		set `echo $REPLYTO | sed -e "s/(.*)//" -e "s/.*<//" -e "s/>.*//"` 
		AD=$1
	        REPLYTO="$AD@$ORGDOM ($GCOS)"
	fi
fi

if [ "$REPLYTO" = "$ML@$DOMAIN" ]
then
	REPLYTO=
fi

set `$AWK '
	BEGIN {rcv = 0;}
	/^$/, NR == 0 { next;}
	/^From / {next;}
	/^[Ss][Uu][Bb][Jj][Ee][Cc][Tt]:/ {rcv = 1; print; next;}
	/^[ 	]/ && rcv == 1 {print; next;}
	{rcv = 0};'< $HEAD | sed 's/[Ss][Uu][Bb][Jj][Ee][Cc][Tt]: //' | 
	sed 'y/abcdefghijklmnopqrstuvwxyz/ABCDEFGHIJKLMNOPQRSTUVWXYZ/'` ""

SUBJECT=$1

# Make user address.
ERROR=0
if [ "$REPLYTO" ]
then
	ADDRESS=`echo $REPLYTO | sed -e "s/(.*)//" -e "s/.*<//" -e "s/>.*//"`
elif [ "$FROM" ]
then
	ADDRESS=`echo $FROM | sed -e "s/(.*)//" -e "s/.*<//" -e "s/>.*//"`
else
	ADDRESS=$ML-request
	ERROR=1
fi

set $ADDRESS .
ADDRESS=$1

# Get GCOS field.
GCOS="__SGCOS__`echo $FROM | sed  -e 's/<.*>//' -e 's/.*(//' -e 's/).*//'`__EGCOS__"

set $GCOS $FROM . ..
if [ "$1" = "$2" ]
then
	GCOS=
fi

SENDSUB="Control command '$SUBJECT' execute"

if [ "$MANUALADD" ]
then
	SUBJECT=MANUALADD
	SENDSUB="Appending message from $ML ML admin"
	AUTOADD="DO"
fi

TOMEMB=0
TOUSER=0
ORGADRS=

case $SUBJECT in
GET|GETDGST|LIST)
	if [ "$ARCHIVE" != "DO" ]
	then
		ERROR=1
		SUBJECT="X-$SUBJECT"
		TOUSER=1
	fi

	if [ "$ACCESSFREE" != "DO" ]
	then
		set `cat $BODY` .
		NUM="`expr 000$1 : '.*\(....\)$'`"
		KEY=$2
		USER=`egrep "^$NUM" $LIST`
		if [ "$USER" ]
		then
			set `echo $USER` .
			ORGKEY=$4

			if [ "$KEY" != "$ORGKEY" ]
			then
				ERROR=1
			fi
		else
			ERROR=1
		fi
	fi
	;;
esac

case $SUBJECT in
GET|GETDGST|LIST)
	# Command is 'Get saved article'.

	cd $SPOOL
	FILEMIN=`ls | egrep "[0-9][0-9][0-9][0-9][0-9]" | sort -n  | head -1`
	FILEMAX=`ls | egrep "[0-9][0-9][0-9][0-9][0-9]" | sort -nr | head -1`

	# check command line
	cat $BODY | \
	sed 'y/abcdefghijklmnopqrstuvwxyz/ABCDEFGHIJKLMNOPQRSTUVWXYZ/' | \
	sed -e "s/^[ 	]*//" |\
	egrep "^$SUBJECT" | \
		sed -e 's/GETDGST//' -e 's/GET//' -e 's/LIST//' > $TEMP
	SYNOK=0
	for i in `sed 's/,/ /g' < $TEMP`
	do
		case $i in
		ALL)
			SYNOK=1
			MIN=$FILEMIN
			MAX=$FILEMAX
			I=$MIN
			while [ $I -le $MAX ]
			do
				CUR=`expr 0000$I : '.*\(.....\)$'`
				if [ -s $CUR ]
				then	
					FILES="$FILES $CUR"
				fi
				I=`expr $I + 1`
			done
			;;
		[0-9]*-[0-9]*|-[0-9]*|[0-9]*-)
			SYNOK=1
			MIN=`expr $i : '^\(.*\)-'`
			MAX=`expr $i : '.*-\(.*\)$'`
			if [ ! "$MIN" ]
			then
				MIN=$FILEMIN
			fi
			if [ ! "$MAX" ]
			then
				MAX=$FILEMAX
			fi
				expr $MIN + $MAX >/dev/null 2>&1
			if [ $? -ne 0 ]
			then
				SYNOK=0
				ERROR=1
				SUBJECT=
			else
				I=$MIN
				while [ $I -le $MAX ]
				do
					CUR=`expr 0000$I : '.*\(.....\)$'`
					if [ -s $CUR ]
					then	
						FILES="$FILES $CUR"
					fi
					I=`expr $I + 1`
				done
			fi
			;;
		[0-9]*)
			SYNOK=1
			I="`expr 0000$i : '.*\(.....\)$'`"
			expr $I + 0 >/dev/null 2>&1
			if [ $? -ne 0 ]
			then
				SYNOK=0
				ERROR=1
				SUBJECT=
				break
			fi		
			if [ -s $I ]
			then
				FILES="$FILES $I"
			fi
			;;
		esac
	done

	if [ ! "$FILES" ]
	then
		if [ $SYNOK -eq 1 ]
		then
			cat $DRIVER/$MESSAGES/noart		> $SEND
			cat $HEAD			       >> $SEND
			cat $BODY			       >> $SEND

			SENDSUB="No article in archive."
			TOUSER=1
			TOMEMB=0
			SUBJECT=
		else
			ERROR=1
		fi
	elif [ "$SUBJECT" = "LIST" ]
	then
		if [ "$LISTLIMIT" ]
		then
			set $FILES
			if [ $# -gt $LISTLIMIT ]
			then
				cat $DRIVER/$MESSAGES/biglist	> $SEND
				cat $HEAD		       >> $SEND
				cat $BODY		       >> $SEND

				SENDSUB="Too big lists"
				TOUSER=1
				TOMEMB=0
				SUBJECT=
			fi
		fi
	fi
	case $SUBJECT in
	GET)
		tar cf - $FILES|compress|uuencode files.tar.Z   > $SEND
		if [ "$GETLIMIT" ]
		then
			set `wc -c $SEND` 0
			S=$1
			GETLIMIT=`expr $GETLIMIT \* 1000`
			set $FILES
			if [ $# -gt 1 -a $S -gt $GETLIMIT ]
			then
				cat $DRIVER/$MESSAGES/bigart    > $SEND
				cat $HEAD                      >> $SEND
				cat $BODY                      >> $SEND
				SENDSUB="Too big archive"
				TOMEMB=0
			fi
		fi
		TOUSER=1
		;;
	GETDGST)
		S=0
		for i in $FILES
		do
			if [ $S -eq 0 ]
			then
				echo "-------- $ML ML Archive --------" > $SEND
				S=1
			else
				echo ""                                >> $SEND
				echo "--------"                        >> $SEND
			fi
			echo ""                                        >> $SEND
			sed -e 's/^-/- -/' $i                          >> $SEND
		done
		echo "-------- End of Archive  -------"                >> $SEND

		if [ "$GETLIMIT" ]
		then
			set `wc -c $SEND` 0
			S=$1
			GETLIMIT=`expr $GETLIMIT \* 1000`
			set $FILES
			if [ $# -gt 1 -a $S -gt $GETLIMIT ]
			then
				cat $DRIVER/$MESSAGES/bigart    > $SEND
				cat $HEAD                      >> $SEND
				cat $BODY                      >> $SEND

				SENDSUB="Too big archive"
				TOMEMB=0
			fi
		fi
		TOUSER=1
		;;
	LIST)
		for j in $FILES
		do
			if [ ! -s $j ]
			then
				echo "$j:  Not archived." >> $SEND
			else
				sed -n -e '1,/^$/p' < $j > $HEAD
				FROM=`egrep "^[Ff][Rr][Oo][Mm]:" $HEAD | \
				       sed 's/[Ff][Rr][Oo][Mm]: //'`
				SUBJECT=`egrep "^[Ss][Uu][Bb][Jj][Ee][Cc][Tt]:" $HEAD | \
				sed -e 's/^[Ss][Uu][Bb][Jj][Ee][Cc][Tt]:[ 	]*\[[A-z0-9=+-]*:[0-9]*\][ 	]*//' \
				    -e 's/^[Ss][Uu][Bb][Jj][Ee][Cc][Tt]:[ 	]*\[[A-z0-9=+-]*\][ 	]*//' \
				    -e 's/^[Ss][Uu][Bb][Jj][Ee][Cc][Tt]:[ 	]*//'`
				echo "$j: $SUBJECT = $FROM" >> $SEND
			fi
		done
		TOUSER=1
		;;
	*)
		;;
	esac
	;;
HELP|MANUAL)
	echo "s/%AdMiN%/$ML-request@$DOMAIN/
	      s/%CNtLAdRs%/$MYADDRESS/
	      s/%MlNaMe%/$ML@$DOMAIN/
	"> $TEMP
	sed -f $TEMP < $DRIVER/$MESSAGES/help			 > $SEND
	if [ -f $DRIVER/$ML/info.$ML ]
	then
		echo "--<Information of $ML ML>----------"	>> $SEND
		cat $DRIVER/$ML/info.$ML			>> $SEND
	fi
	sed -f $TEMP < $DRIVER/$MESSAGES/manual.1st		>> $SEND
	if [ "$ARCHIVE" = "DO" ]
	then
		if [ "$ACCESSFREE" = "DO" ]
		then
			cat $DRIVER/$MESSAGES/manual.arc	>> $SEND
			cat $DRIVER/$MESSAGES/manual.ex		>> $SEND
			cat $DRIVER/$MESSAGES/manual.ex.arc	>> $SEND
		else
			cat $DRIVER/$MESSAGES/manual.arc2	>> $SEND
			cat $DRIVER/$MESSAGES/manual.ex		>> $SEND
			cat $DRIVER/$MESSAGES/manual.ex.arc2	>> $SEND
		fi
	else
		cat $DRIVER/$MESSAGES/manual.ex			>> $SEND
	fi
	echo "-EOF-"						>> $SEND

	TOUSER=1
	;;
CHECK)
	sed -e 's/</(/g' -e 's/>/)/g' < $LIST | \
		$GREP -i "($ADDRESS)" >/dev/null 2>&1
	if [ $? -eq 0 ]
	then
		echo "ML=$ML@$DOMAIN"          >> $SEND
		set `sed -e 's/</(/g' -e 's/>/)/g' < $LIST | $GREP -i "($ADDRESS)"`
		NU=$1
		ST=$2
		AD=`echo $3 | sed -e "s/<//" -e "s/>//" -e "s/(//" -e "s/)//"`
		PW=$4

		echo ""				>> $SEND
		echo "****** Your Status ******">> $SEND
		echo "NUMB|STAT|KEYWORD|ADDRESS">> $SEND
		echo "----+----+-------+-------">> $SEND

		GC="`$GREP $NU $GCOSFILE | 
		     sed -e 's/^[0-9]* //' -e 's/[ 	]*$//`"
		if [ "$GC" != "" ]
		then
			echo "$NU|$ST| $PW  |$AD ($GC)" >> $SEND
		else
			echo "$NU|$ST| $PW  |$AD"        >> $SEND
		fi

		TOUSER=1
	else
		echo "ML=$ML@$DOMAIN"                    >> $SEND
		echo ""			                 >> $SEND
		echo "You ($ADDRESS) are not ML member." >> $SEND
		echo "-EOF-"				 >> $SEND
		TOUSER=1
	fi
	;;
APPEND|MANUALADD)
	if [ "$AUTOADD" = "DO" ]
	then

		# Get Lock.
		DELAY=`expr $MYPID % 6`

		# Get delay time.
		case "$DELAY" in
		0)	set 1 2 3 3 2 1 ;;
		1)	set 1 3 2 1 2 3 ;;
		2)	set 2 1 3 1 3 2 ;;
		3)	set 2 3 1 2 1 3 ;;
		4)	set 3 1 2 2 3 1 ;;
		*)	set 3 2 1 3 1 2 ;;
		esac

		umask 077
		until ln $LKEY $LOCK >/dev/null 2>&1
		do
			DELAY=$1
			shift
			set $@ $DELAY
			sleep $DELAY
		done
		# Lock comprele.
		umask 022

		# Add user address to member list.
		if [ ! -f $LIST ]
		then
			if [ ! -d $DRIVER/$ML ]
			then
				mkdir $DRIVER/$ML
			fi
			NUM=0001
		else
			NUM=`sort -n $LIST | tail -1 | $AWK '{ print $1 }'`
			if [ ! "$NUM" ]
			then
				NUM=0
			fi
			NUM=`expr $NUM + 1`
			NUM=`expr 000$NUM : '.*\(....\)$'`
		fi

		ID=`echo $ADDRESS | sed -e 's/@.*//'`
		KEY=`expr 0000$$ : '.*\(....\)$'`

		# Duplicate check.
		sed -e 's/</(/g' -e 's/>/)/g' < $LIST | \
			 $GREP -i "($ADDRESS)" >/dev/null 2>&1
		if [ $? -eq 0 ]
		then
			echo "s/%MlNaMe%/$ML@$DOMAIN/" > $TEMP
			sed -f $TEMP < $DRIVER/$MESSAGES/duplicate  > $SEND
			set `sed -e 's/</(/g' -e 's/>/)/g' < $LIST | $GREP -i "($ADDRESS)"`

			NU=$1
			ST=$2
			AD=`echo $3 | sed -e "s/<//" -e "s/>//" -e "s/(//" -e "s/)//"`
			PW=$4

			echo ""				>> $SEND
			echo "****** Your Status ******">> $SEND
			echo "NUMB|STAT|KEYWORD|ADDRESS">> $SEND
			echo "----+----+-------+-------">> $SEND

			GC="`$GREP $NU $GCOSFILE | \
			sed -e 's/^[0-9]* //' -e 's/[ 	]*$//`"
			if [ "$GC" != "" ]
			then
				echo "$NU|$ST| $PW  |$AD ($GC)" >> $SEND
			else
				echo "$NU|$ST| $PW  |$AD"        >> $SEND
			fi

			TOUSER=1
		else
			USERINFO="$NUM SEND <$ADDRESS> $KEY"
			SMODE="SEND"
			# check default digest
			if [ "$DGSTAPPEND" = "DO" ]
			then
				FROMDOM=`echo $ADDRESS |\
		                $AWK '{
		                        l = length($0);

		                        for ( ; l > 0; l-- ) {
		                                printf("%s",substr($0, l, 1));
                	        	}
					printf( "\n" );
		                }' | sed -e 's/@.*//' | \
		                $AWK '{
		                        l = length($0);

		                        for ( ; l > 0; l-- ) {
		                                printf("%s",substr($0, l, 1));
		                        }
		                        printf( "\n" );
		                }'`

				if [ -f $DRIVER/$ML/defaultdigest ]
				then
					for i in `cat $DRIVER/$ML/defaultdigest`
					do
						echo $FROMDOM | $GREP "$i" >/dev/null 2>&1
						if [ $? -eq 0 ]
						then
							USERINFO="$NUM DGST ($ADDRESS) $KEY <nobody>"
							SMODE="DGST"
						fi
					done
				fi
			fi
			echo $USERINFO >> $LIST

			# Write user profile.
			if [ ! -d $PROFILE ]
			then
				mkdir $PROFILE
			fi

			if [ -s $BODY ]
			then
				echo "<<Last Modified: `date`>>" >$PROFILE/$NUM
				cat $BODY			>>$PROFILE/$NUM
			fi

			echo "$NUM `echo $GCOS | sed -e 's/^__SGCOS__//' -e 's/__EGCOS__$//'`" | b64decode >> $GCOSFILE
			SEDADD=`echo $ADDRESS | sed -e 's/\//\\\\\//g'`

			echo "s/%NuMbEr%/$NUM/
			      s/%AdDrEsS%/$SEDADD/
			      s/%kEyWd%/$KEY/
			      s/%AdMiN%/$ML-request@$DOMAIN/
			      s/%CNtLAdRs%/$MYADDRESS/
			      s/%MlNaMe%/$ML@$DOMAIN/
			      s/%mOdE%/$SMODE/
			" > $TEMP
			sed -f $TEMP < $DRIVER/$MESSAGES/append >  $SEND

			if [ -f $DRIVER/$ML/info.$ML ]
			then
				echo "--<Information of $ML ML>----------" >> $SEND
				cat $DRIVER/$ML/info.$ML		   >> $SEND
			fi
			sed -f $TEMP < $DRIVER/$MESSAGES/manual.1st >> $SEND
			if [ "$ARCHIVE" = "DO" ]
			then
				if [ "$ACCESSFREE" = "DO" ]
				then
					cat $DRIVER/$MESSAGES/manual.arc	>> $SEND
					cat $DRIVER/$MESSAGES/manual.ex		>> $SEND
					cat $DRIVER/$MESSAGES/manual.ex.arc	>> $SEND
				else
					cat $DRIVER/$MESSAGES/manual.arc2	>> $SEND
					cat $DRIVER/$MESSAGES/manual.ex		>> $SEND
					cat $DRIVER/$MESSAGES/manual.ex.arc2	>> $SEND
				fi
			else
				cat $DRIVER/$MESSAGES/manual.ex	    >> $SEND
			fi
			echo "-EOF-"				    >> $SEND

			TOUSER=1

			AD="$ADDRESS"
			if [ "$GCOS" != "" ]
			then
				AD="$ADDRESS (`echo $GCOS | sed -e 's/^__SGCOS__//' -e 's/__EGCOS__$//'`)"
			fi
			SEDADD=`echo $AD | sed -e 's/\//\\\\\//g'`
			echo "s/%NuMbEr%/$NUM/
			      s/%AdDrEsS%/$SEDADD/
			      s/%kEyWd%/$KEY/
			      s/%AdMiN%/$ML-request@$DOMAIN/
			      s/%CNtLAdRs%/$MYADDRESS/
			      s/%MlNaMe%/$ML@$DOMAIN/
			      s/%mOdE%/$SMODE/
			" > $TEMP

			sed -f $TEMP < $DRIVER/$MESSAGES/add	> $SYSM
			if [ "$MANUALADD" ]
			then
				sed -f $TEMP < $DRIVER/$MESSAGES/add.manual > $SYSM
			fi
			cat $PROFILE/$NUM		       >> $SYSM
			SYSSUB="Append member."
			TOMEMB=1
		fi
		rm -rf $LOCK
	else
		SENDSUB="Append message from $ADDRESS"
		ADDRESS=$ML-request@$DOMAIN
		cat $HEAD $BODY > $SEND
		TOUSER=1
	fi
	;;
PING|GCOS|MEMBER|DIGEST|STOP|SEND|DELETE|INTRO|PROFILE|ADDRESS|KEYWORD)
	set `cat $BODY` .
	NUM="`expr 000$1 : '.*\(....\)$'`"
	KEY=$2
	USER=`egrep "^$NUM" $LIST`
	if [ "$USER" ]
	then
		set `echo $USER` .
		ORGKEY=$4

		if [ "$KEY" != "$ORGKEY" ]
		then
			ERROR=1
		fi
	else
		ERROR=1
	fi

	if [ $ERROR -eq 0 ]
	then
		case $SUBJECT in
		PING)
			echo "**** Your control mail header ***********" >$SEND
			cat $HEAD                                      >> $SEND
			set `sed -e 's/</(/g' -e 's/>/)/g' < $LIST | $GREP -i "($ADDRESS)" >/dev/null 2>&1`
			NU=$1
			ST=$2
			AD=`echo $3 | \
			    sed -e "s/<//" -e "s/>//" -e "s/(//" -e "s/)//"`
			PW=$4

			echo "****** Your Status ******">> $SEND
			echo "NUMB|STAT|KEYWORD|ADDRESS">> $SEND
			echo "----+----+-------+-------">> $SEND

			GC="`$GREP $NU $GCOSFILE | \
			sed -e 's/^[0-9]* //' -e 's/[ 	]*$//`"
			if [ "$GC" != "" ]
			then
				echo "$NU|$ST| $PW  |$AD ($GC)"        >> $SEND
			else
				echo "$NU|$ST| $PW  |$AD"              >> $SEND
			fi

			if [ "$ARCHIVE" = "DO" ]
			then
				echo ""                                        >> $SEND
				echo "**** Last article **********************">> $SEND
				cd $SPOOL
				FILEMAX=`ls |\
					 egrep "[0-9][0-9][0-9][0-9][0-9]" |\
					 sort -nr | head -1`
				sed -n -e '1,/^$/p' < $FILEMAX > $HEAD
				FROM=`egrep "^[Ff][Rr][Oo][Mm]:" $HEAD |\
				      sed 's/[Ff][Rr][Oo][Mm]: //'`

				****
				SUBJECT=`egrep "^[Ss][Uu][Bb][Jj][Ee][Cc][Tt]:" $HEAD|\
					 sed -e 's/[Ss][Uu][Bb][Jj][Ee][Cc][Tt]:[ 	]*\[[A-z0-9=+-]*:[0-9]*\][ 	]*//'`
				echo "$FILEMAX: $SUBJECT = $FROM"              >> $SEND
			fi
				 
			TOUSER=1
			;;
		MEMBER)
			echo "NUMB|STAT|ADDRESS"			> $SEND
			echo "----+----+----------------------------"  >> $SEND

			$AWK '{ printf "%s|%s|%s\n",$1,$2,$3 }' < $LIST	|\
			sed -e "s/<//" -e "s/>//" -e "s/(//" -e "s/)//" |\
			sort -n					        > $TEMP

			while read D
			do
				set `echo $D | sed -e 's/|/ /g'`
				GC=`egrep "^$1" $GCOSFILE | \
				sed -e 's/^[0-9]* //' -e 's/[ 	]*$//`
				if [ "$GC" != "" ]
				then
					echo "$D ($GC)"                >> $SEND
				else
					echo "$D"                      >> $SEND
				fi
			done < $TEMP
			echo "----+----+----------------------------"  >> $SEND
			TOUSER=1
			;;
		DIGEST)
			# Get lock.
			DELAY=`expr $MYPID % 6`

			# Get delay time.
			case "$DELAY" in
			0)	set 1 2 3 3 2 1 ;;
			1)	set 1 3 2 1 2 3 ;;
			2)	set 2 1 3 1 3 2 ;;
			3)	set 2 3 1 2 1 3 ;;
			4)	set 3 1 2 2 3 1 ;;
			*)	set 3 2 1 3 1 2 ;;
			esac

			umask 077
			until ln $LKEY $LOCK >/dev/null 2>&1
			do
				DELAY=$1
				shift
				set $@ $DELAY
				sleep $DELAY
			done
			# Lock comprele.
			umask 022

			set `echo $USER` .
			NU=$1
			AD=`echo $3 | sed -e "s/<//" -e "s/>//" -e "s/(//" -e "s/)//"`
			PW=$4

			ORGADRS=$AD

			echo "/^$NU /d
                                w
                                q
			" | ed >/dev/null 2>&1 $LIST
			echo "$NU DGST ($AD) $PW <nobody>" >> $LIST

			if [ ! -f $DRIVER/$ML/batchtime ]
			then
				echo "03:00" > $DRIVER/$ML/batchtime
			fi

			echo "s/%NuMbEr%/$NUM/
			      s/%AdDrEsS%/$AD/
			      s/%MlNaMe%/$ML@$DOMAIN/
			"> $TEMP

			sed -f $TEMP < $DRIVER/$MESSAGES/digest  > $SYSM
			cat $DRIVER/$ML/batchtime               >> $SYSM
			echo "-EOF-"                            >> $SYSM

			sed -f $TEMP < $DRIVER/$MESSAGES/digest  > $SEND
			cat $DRIVER/$ML/batchtime               >> $SEND
			echo "-EOF-"                            >> $SEND

			SYSSUB="Send by digest style to $AD."
			TOUSER=1
			TOMEMB=1
			if [ "$DLVMSG" != "DO" ]
			then
				AUTOMSG=DONT
			fi
			rm -f $LOCK
			;;
		STOP)
			# Get lock.
			DELAY=`expr $MYPID % 6`

			# Get delay time.
			case "$DELAY" in
			0)	set 1 2 3 3 2 1 ;;
			1)	set 1 3 2 1 2 3 ;;
			2)	set 2 1 3 1 3 2 ;;
			3)	set 2 3 1 2 1 3 ;;
			4)	set 3 1 2 2 3 1 ;;
			*)	set 3 2 1 3 1 2 ;;
			esac

			umask 077
			until ln $LKEY $LOCK >/dev/null 2>&1
			do
				DELAY=$1
				shift
				set $@ $DELAY
				sleep $DELAY
			done
			# Lock comprele.
			umask 022

			set `echo $USER` .
			NU=$1
			MD=$2
			AD=`echo $3 | sed -e "s/<//" -e "s/>//" -e "s/(//" -e "s/)//"`
			PW=$4
			ORGADRS=$AD

			echo "/^$NU /d
                                w
                                q
			" | ed >/dev/null 2>&1 $LIST
			echo "$NU STOP ($AD) $PW <nobody>" >> $LIST

			echo "s/%NuMbEr%/$NUM/
			      s/%AdDrEsS%/$AD/
			      s/%MlNaMe%/$ML@$DOMAIN/
			"> $TEMP

			sed -f $TEMP < $DRIVER/$MESSAGES/stop > $SYSM
			sed -f $TEMP < $DRIVER/$MESSAGES/stop > $SEND
			SYSSUB="Stop member."
			TOMEMB=1
			TOUSER=1
			if [ "$DLVMSG" != "DO" ]
			then
				AUTOMSG=DONT
			fi

			# Check digest spool.
			if [ "$MD" = "DGST" ]
			then
				cat $DGSTFILE  >> $SEND
				echo ""        >> $SEND
				echo "-------- End Digest of $ML ML --------" >> $SEND
			fi
			echo ""      >> $SEND
			echo "-EOF-" >> $SEND

			rm -f $LOCK
			;;
		SEND)
			# Get lock.
			DELAY=`expr $MYPID % 6`

			# Get delay time.
			case "$DELAY" in
			0)	set 1 2 3 3 2 1 ;;
			1)	set 1 3 2 1 2 3 ;;
			2)	set 2 1 3 1 3 2 ;;
			3)	set 2 3 1 2 1 3 ;;
			4)	set 3 1 2 2 3 1 ;;
			*)	set 3 2 1 3 1 2 ;;
			esac

			umask 077
			until ln $LKEY $LOCK >/dev/null 2>&1
			do
				DELAY=$1
				shift
				set $@ $DELAY
				sleep $DELAY
			done
			# Lock comprele.
			umask 022

			set `echo $USER` .
			NU=$1
			MD=$2
			AD=`echo $3 | sed -e "s/<//" -e "s/>//" -e "s/(//" -e "s/)//"`
			PW=$4

			ORGADRS=$AD

			echo "/^$NU /d
                                w
                                q
			" | ed >/dev/null 2>&1 $LIST
			echo "$NU SEND <$AD> $PW" >> $LIST

			echo "s/%NuMbEr%/$NUM/
			      s/%AdDrEsS%/$AD/
			      s/%MlNaMe%/$ML@$DOMAIN/
			"> $TEMP

			sed -f $TEMP < $DRIVER/$MESSAGES/send > $SYSM
			sed -f $TEMP < $DRIVER/$MESSAGES/send > $SEND
			TOUSER=1
			TOMEMB=1
			SYSSUB="Reregist member."
			if [ "$DLVMSG" != "DO" ]
			then
				AUTOMSG=DONT
			fi

			# Check digest spool.
			if [ "$MD" = "DGST" ]
			then
				cat $DGSTFILE  >> $SEND
				echo ""        >> $SEND
				echo "-------- End Digest of $ML ML --------" >> $SEND
			fi
			echo ""      >> $SEND
			echo "-EOF-" >> $SEND

			rm -f $LOCK
			;;
		DELETE)
			# Get lock.
			DELAY=`expr $MYPID % 6`

			# Get delay time.
			case "$DELAY" in
			0)	set 1 2 3 3 2 1 ;;
			1)	set 1 3 2 1 2 3 ;;
			2)	set 2 1 3 1 3 2 ;;
			3)	set 2 3 1 2 1 3 ;;
			4)	set 3 1 2 2 3 1 ;;
			*)	set 3 2 1 3 1 2 ;;
			esac

			umask 077
			until ln $LKEY $LOCK >/dev/null 2>&1
			do
				DELAY=$1
				shift
				set $@ $DELAY
				sleep $DELAY
			done
			# Lock comprele.
			umask 022

			set `echo $USER` .
			NU=$1
			AD=`echo $3 | sed -e "s/<//" -e "s/>//" -e "s/(//" -e "s/)//"`
			PW=$4

			ORGADRS=$AD

			echo "/^$NU /d
                                w
                                q
			" | ed >/dev/null 2>&1 $GCOSFILE

			echo "/^$NU /d
                                w
                                q
			" | ed >/dev/null 2>&1 $LIST
			echo "$NU QUIT () <nobody>" >> $LIST
			rm -f $PROFILE/$NU

			echo "s/%NuMbEr%/$NUM/
			      s/%AdDrEsS%/$AD/
			      s/%MlNaMe%/$ML@$DOMAIN/
			"> $TEMP

			sed -f $TEMP < $DRIVER/$MESSAGES/delete > $SYSM
			sed -f $TEMP < $DRIVER/$MESSAGES/delete > $SEND
			SYSSUB="Delete member."
			TOMEMB=1
			TOUSER=1
			rm -f $LOCK
			;;
		ADDRESS)
			# Get lock.
			DELAY=`expr $MYPID % 6`

			# Get delay time.
			case "$DELAY" in
			0)	set 1 2 3 3 2 1 ;;
			1)	set 1 3 2 1 2 3 ;;
			2)	set 2 1 3 1 3 2 ;;
			3)	set 2 3 1 2 1 3 ;;
			4)	set 3 1 2 2 3 1 ;;
			*)	set 3 2 1 3 1 2 ;;
			esac

			umask 077
			until ln $LKEY $LOCK >/dev/null 2>&1
			do
				DELAY=$1
				shift
				set $@ $DELAY
				sleep $DELAY
			done
			# Lock comprele.
			umask 022

			echo "s/%MlNaMe%/$ML@$DOMAIN/"> $TEMP

			sed -f $TEMP < $DRIVER/$MESSAGES/address > $SEND
			set `echo $USER` .
			NU=$1
			OA=`echo $3 | sed -e "s/<//" -e "s/>//" -e "s/(//" -e "s/)//"`
			PW=$4

			set `cat $BODY | \
			sed 'y/ABCDEFGHIJKLMNOPQRSTUVWXYZ/abcdefghijklmnopqrstuvwxyz/' | \
			egrep "^address"` . .

			AD=$2

			ORGADRS=$AD

			if [ "$AD" = "." ]
			then
				ERROR=1
			else
				set `egrep "^$NU" $LIST` . .
				MODE=$2
				echo "/^$NU /d
                                        w
                                        q
				" | ed >/dev/null 2>&1 $LIST

				if [ "$MODE" = "SEND" ]
				then
					UINFO="$NU SEND <$AD> $PW"
				else
					UINFO="$NU $MODE ($AD) $PW <nobody>"
				fi
				echo $UINFO >> $LIST

				echo "$OA -> $AD"		>> $SEND
				echo ""				>> $SEND
				echo "****** Your Status ******">> $SEND
				echo "NUMB|STAT|KEYWORD|ADDRESS">> $SEND
				echo "----+----+-------+-------">> $SEND

				GC="`$GREP $NU $GCOSFILE | \
				sed -e 's/^[0-9]* //' -e 's/[ 	]*$//`"
				if [ "$GC" != "" ]
				then
					echo "$NU|$MODE| $PW  |$AD ($GC)">>$SEND
				else
					echo "$NU|$MODE| $PW  |$AD"      >>$SEND
				fi

				TOUSER=1
			fi
			rm -f $LOCK
			;;
		INTRO)

			echo "s/%MlNaMe%/$ML@$DOMAIN/"> $TEMP
			sed -f $TEMP < $DRIVER/$MESSAGES/intro > $SEND

			set `echo $USER` .
			NU=$1
			sed -n -e '/^./,$p' < $BODY > $TEMP
			set `wc -l $TEMP`
			LINE=`expr $1 - 1`
			echo "<<Last Modified: `date`>>" > $PROFILE/$NUM
			tail -$LINE $TEMP		>> $PROFILE/$NUM

			cat $PROFILE/$NUM >> $SEND
			TOUSER=1
			;;
		KEYWORD)
			# Get lock.
			DELAY=`expr $MYPID % 6`

			# Get delay time.
			case "$DELAY" in
			0)	set 1 2 3 3 2 1 ;;
			1)	set 1 3 2 1 2 3 ;;
			2)	set 2 1 3 1 3 2 ;;
			3)	set 2 3 1 2 1 3 ;;
			4)	set 3 1 2 2 3 1 ;;
			*)	set 3 2 1 3 1 2 ;;
			esac

			umask 077
			until ln $LKEY $LOCK >/dev/null 2>&1
			do
				DELAY=$1
				shift
				set $@ $DELAY
				sleep $DELAY
			done
			# Lock comprele.
			umask 022

			echo "s/%MlNaMe%/$ML@$DOMAIN/"> $TEMP

			sed -f $TEMP < $DRIVER/$MESSAGES/keyword > $SEND
 
			set `echo $USER` .
			NU=$1
			AD=`echo $3 |\
			sed -e "s/<//" -e "s/>//" -e "s/(//" -e "s/)//"`
			OP=$4

			ORGADRS=$AD
 
			set `cat $BODY | \
			sed 'y/ABCDEFGHIJKLMNOPQRSTUVWXYZ/abcdefghijklmnopqrstuvwxyz/' | \
			egrep "^keyword [0-9][0-9][0-9][0-9]"` . .
 
			PW=$2
			if [ "$PW" = "." ]
			then
				ERROR=1
			else

				KE=`expr $PW : '.*\(....\)$'`
				if [ "$PW" = "$KE" ]
				then
					set `egrep "^$NU" $LIST` . .
					MODE=$2
					echo "/^$NU /d
                                                w
                                                q
					" | ed >/dev/null 2>&1 $LIST
					if [ "$MODE" = "SEND" ]
					then
						UINFO="$NU SEND <$AD> $PW"
					else
						UINFO="$NU $MODE ($AD) $PW <nobody>"
					fi
					echo $UINFO >> $LIST
 
					echo "$OP -> $PW"		>> $SEND
					echo ""				>> $SEND
					echo "****** Your Status ******">> $SEND
					echo "NUMB|STAT|KEYWORD|ADDRESS">> $SEND
					echo "----+----+-------+-------">> $SEND

					GC="`$GREP $NU $GCOSFILE | \
					sed -e 's/^[0-9]* //' -e 's/[ 	]*$//`"
					if [ "$GC" != "" ]
					then
						echo "$NU|$MODE| $PW  |$AD ($GC)">>$SEND
					else
						echo "$NU|$MODE| $PW  |$AD"      >>$SEND
					fi

					TOUSER=1
				else
					ERROR=1
				fi
			fi
			rm -f $LOCK
			;;

		GCOS)
			# Get lock.
			DELAY=`expr $MYPID % 6`

			# Get delay time.
			case "$DELAY" in
			0)	set 1 2 3 3 2 1 ;;
			1)	set 1 3 2 1 2 3 ;;
			2)	set 2 1 3 1 3 2 ;;
			3)	set 2 3 1 2 1 3 ;;
			4)	set 3 1 2 2 3 1 ;;
			*)	set 3 2 1 3 1 2 ;;
			esac

			umask 077
			until ln $LKEY $LOCK >/dev/null 2>&1
			do
				DELAY=$1
				shift
				set $@ $DELAY
				sleep $DELAY
			done
			# Lock comprele.
			umask 022

			echo "s/%MlNaMe%/$ML@$DOMAIN/"> $TEMP
			sed -f $TEMP < $DRIVER/$MESSAGES/gcos > $SEND
 
			set `echo $USER` .
			NU=$1
			AD=`echo $3 |\
			sed -e "s/<//" -e "s/>//" -e "s/(//" -e "s/)//"`
			OP=$4
 
			GCOS="`$GREP -i GCOS $BODY | head -1 | sed -e 's/[ 	]*[Gg][Cc][Oo][Ss][ 	]*//'`"

			if [ "$GCOS" = "" ]
			then
				ERROR=1
			else
				echo "/^$NU /d
                                        w
                                        q
				" | ed >/dev/null 2>&1 $GCOSFILE
				echo "$NU $GCOS" | sed -e 's/[ 	]*$//' >> $GCOSFILE
				echo ""          >> $SEND
				echo "$NU $GCOS" >> $SEND
				TOUSER=1
			fi
			rm -f $LOCK
			;;

		PROFILE)
			cd $PROFILE

			FILEMIN=`ls | egrep "[0-9][0-9][0-9][0-9]" | sort -n  | head -1`
			FILEMAX=`ls | egrep "[0-9][0-9][0-9][0-9]" | sort -nr | head -1`

			if [ "$FILEMIN" = "" ]
			then
				FILEMIN=1
			fi
			if [ "$FILEMAX" = "" ]
			then
				FILEMAX=1
			fi

			cat $BODY | \
			sed 'y/abcdefghijklmnopqrstuvwxyz/ABCDEFGHIJKLMNOPQRSTUVWXYZ/' |\
			egrep '^[ 	]*PROFILE' |\
			sed -e 's/^[ 	]*PROFILE[ 	]*//' > $TEMP

			set X`cat $TEMP`

			if [ "$1" = "X" ]
			then
				echo ALL > $TEMP
			fi

			SYNOK=0
			for i in `sed 's/,/ /g' < $TEMP`
			do
				case $i in
				ALL)
					SYNOK=1
					MIN=$FILEMIN
					MAX=$FILEMAX
					I=$MIN
					while [ $I -le $MAX ]
					do
						CUR=`expr 000$I : '.*\(....\)$'`
						if [ -s $CUR ]
						then
							FILES="$FILES $CUR"
						fi
						I=`expr $I + 1`
					done
					;;
				[0-9]*-[0-9]*|-[0-9]*|[0-9]*-)
					SYNOK=1
					MIN=`expr $i : '^\(.*\)-'`
					MAX=`expr $i : '.*-\(.*\)$'`
					if [ ! "$MIN" ]
					then
						MIN=$FILEMIN
					fi
					if [ ! "$MAX" ]
					then
						MAX=$FILEMAX
					fi
					expr $MIN + $MAX >/dev/null 2>&1
					if [ $? -ne 0 ]
					then
						SYNOK=0
						ERROR=1
						SUBJECT=
					else
						I=$MIN
						while [ $I -le $MAX ]
						do
							CUR=`expr 000$I : '.*\(....\)$'`
							if [ -s $CUR ]
							then
								FILES="$FILES $CUR"
							fi
							I=`expr $I + 1`
						done
					fi
					;;
				[0-9]*)
					SYNOK=1
					I="`expr 000$i : '.*\(....\)$'`"
					expr $I + 0 >/dev/null 2>&1
					if [ $? -ne 0 ]
					then
						SYNOK=0
						ERROR=1
						SUBJECT=
						break
					fi
					if [ -s $I ]
					then
						FILES="$FILES $I"
					fi
					;;
				esac
			done

			if [ ! "$FILES" ]
			then
				if [ $SYNOK -eq 1 ]
				then
					cat $DRIVER/$MESSAGES/noprof  > $SEND
					cat $HEAD		     >> $SEND
					cat $BODY		     >> $SEND

					SENDSUB="No profile is good profile"
					TOUSER=1
					TOMEMB=0
					SUBJECT=
				else
					ERROR=1
				fi
			fi

			if [ "$SUBJECT" ]
			then
				cd $PROFILE
				echo "** Profile of $ML@$DOMAIN **"  > $SEND
				for i in $FILES
				do
					egrep "^$i" $LIST | $AWK '{
					 printf("\n>>> %s: %s (%s) <<<\n", $1,$3,$2)
					}'			    >> $SEND
					cat $i			    >> $SEND
				done
				TOUSER=1
			fi
			;;
		*)
			;;
		esac
	fi
	;;
*)
	ERROR=1
	;;
esac

if [ $ERROR -eq 1 ]
then
	echo "s/%CNtLAdRs%/$MYADDRESS/
	      s/%MlNaMe%/$ML@$DOMAIN/
	"> $TEMP

	cat $DRIVER/$MESSAGES/error				 > $SEND
	cat $HEAD						>> $SEND
	cat $BODY						>> $SEND
	sed -f $TEMP < $DRIVER/$MESSAGES/manual.1st		>> $SEND
	if [ "$ARCHIVE" = "DO" ]
	then
		if [ "$ACCESSFREE" = "DO" ]
		then
			cat $DRIVER/$MESSAGES/manual.arc	>> $SEND
			cat $DRIVER/$MESSAGES/manual.ex		>> $SEND
			cat $DRIVER/$MESSAGES/manual.ex.arc	>> $SEND
		else
			cat $DRIVER/$MESSAGES/manual.arc2	>> $SEND
			cat $DRIVER/$MESSAGES/manual.ex		>> $SEND
			cat $DRIVER/$MESSAGES/manual.ex.arc2	>> $SEND
		fi
	else
		cat $DRIVER/$MESSAGES/manual.ex			>> $SEND
	fi
	echo "-EOF-"						>> $SEND


	SENDSUB="$SENDSUB error"
	TOUSER=1
	TOMEMB=0
fi

# mail send to user
if [ "$ORGADRS" = "." ]
then
	ORGADRS=
fi

if [ $TOUSER -eq 1 ]
then
	echo "To: $ADDRESS"			         > $HEAD
	if [ "$ORGADRS" != "" -a "$ADDRESS" != "$ORGADRS" ]
	then
		echo "Cc: $ORGADRS"                     >> $HEAD
	fi
	echo "From: $ML-request@$DOMAIN ($ML ML admin)" >> $HEAD
	echo "Subject: $SENDSUB."		        >> $HEAD
	echo "Errors-To: $ML-request@$DOMAIN"	        >> $HEAD
	echo "X-ML-Driver: CMAS (Version $VERSION)"     >> $HEAD

	if [ "$SUBJECT" = "GET" ]
	then
		if [ "$REPLYTO" ]
		then
			echo "Reply-To: $REPLYTO"       >> $HEAD
		else
			echo "Reply-To: $ML@$DOMAIN"    >> $HEAD
		fi
	fi

	if [ "$SENDER" ]
	then
		echo "Sender: $SENDER"			>> $HEAD
	fi

	if [ "$PRECEDENCE" ]
	then
		echo "Precedence: $PRECEDENCE"		>> $HEAD
	fi
	echo ""						>> $HEAD

	cat $HEAD $SEND | b64decode| $SENDMAIL -oi -t -f$UnixFrom
fi

if [ $TOMEMB -eq 1 ]
then
	if [ "$AUTOMSG" = "DO" ]
	then
		echo "To: $ML@$DOMAIN"		         > $HEAD
	else
		echo "To: $ML-request@$DOMAIN"	         > $HEAD
	fi

	echo "From: $ML-request@$DOMAIN ($ML ML admin)" >> $HEAD
	echo "Subject: $SYSSUB"			        >> $HEAD

	if [ "$SENDER" ]
	then
		echo "Sender: $SENDER"		        >> $HEAD
	fi

	if [ "$PRECEDENCE" ]
	then
		echo "Precedence: $PRECEDENCE"		>> $HEAD
	fi
	echo ""					        >> $HEAD

	cat $HEAD $SYSM | b64decode | $SENDMAIL -oi -t -f$UnixFrom
fi

exit 0
